'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var getterAndSetter = {
    get: true,
    set: true
};

var MethodDefinition = (function (_Node) {
    _inherits(MethodDefinition, _Node);

    function MethodDefinition(childNodes) {
        _classCallCheck(this, MethodDefinition);

        _get(Object.getPrototypeOf(MethodDefinition.prototype), 'constructor', this).call(this, 'MethodDefinition', childNodes);
    }

    _createClass(MethodDefinition, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var key = undefined;
            var computed = undefined;
            var value = undefined;
            var kind = undefined;
            var staticMember = false;

            if (children.isToken('Identifier', 'static')) {
                staticMember = true;
                children.passToken();
                children.skipNonCode();
            }

            if (children.isToken('Identifier', getterAndSetter)) {
                kind = children.currentElement.value;
                children.passToken();
                children.skipNonCode();
            } else {
                kind = 'method';
            }

            if (children.isNode('Identifier')) {
                computed = false;
                key = children.passNode();
                if (kind === 'method' && key.type === 'Identifier' && key.name === 'constructor') {
                    kind = 'constructor';
                }
                children.skipNonCode();
            } else {
                computed = true;
                children.passToken('Punctuator', '[');
                children.skipNonCode();
                key = children.passExpression();
                children.skipNonCode();
                children.passToken('Punctuator', ']');
                children.skipNonCode();
            }

            value = children.passNode('FunctionExpression');

            children.assertEnd();

            this._kind = kind;
            this._key = key;
            this._value = value;
            this._computed = computed;
            this._static = staticMember;
        }
    }, {
        key: 'key',
        get: function get() {
            return this._key;
        }
    }, {
        key: 'value',
        get: function get() {
            return this._value;
        }
    }, {
        key: 'kind',
        get: function get() {
            return this._kind;
        }
    }, {
        key: 'static',
        get: function get() {
            return this._static;
        }
    }]);

    return MethodDefinition;
})(_Node3['default']);

exports['default'] = MethodDefinition;
module.exports = exports['default'];